<?php 
/**
 * fsWorkhorse - Workhorse for generating output for Flickr-Stream
 *
 * @package Flickr-Stream
 * @author Dustin Scarberry
 *
 * @since 1.1.5
 */
class fsWorkhorse
{

	private $_content, $_mainopts, $_opts, $_relgen;

	public function __construct(){
	
		$this->_mainopts = get_option('flickrstream_main_opts');
	
	}
	
	public function returnPhotos($type, $opts, $extra)
	{
	
		$this->_opts = $opts;
		$this->_relgen = rand();
	
		if($extra != null)
			extract($extra);
		
		if(!isset($this->_opts['thumbsize']))
			$this->_opts['thumbsize'] = 'Small';
			
		if($this->_opts['cachedata'] == 'on')
		{
		
			if($this->_opts['hidetitle'] == 'off')
			{
			
				if($type == 'shortcode')
					$this->_content .= '<h3 class="fsSetTitle">' . $this->_opts['cache']['name'] . '</h3>';
				else
					$this->_content .= $before_title . $this->_opts['cache']['name'] . $after_title;
			
			}
		
		
			for($i = 0; $i < $this->_opts['photocnt']; $i++)
			{
				
				if($this->_opts['linktype'] == 'Flickr')
				{
					
					$this->_content .= '<a href="' . $this->_opts['cache']['photos'][$i]['flickr'] . '" title="' . $this->_opts['cache']['photos'][$i]['title'] . '" target="_blank"><img src="' . substr_replace($this->_opts['cache']['photos'][$i]['url'], '_s.jpg', -6) . '"/></a>';

				}
				else
				{
					
					$this->_content .= '<a href="' . $this->_opts['cache']['photos'][$i]['url'] . '"' . ($this->_opts['hidecaption'] == 'off' ? 'title="' . $this->_opts['cache']['photos'][$i]['title'] . '"' : '') . ' class="fsFancybox" rel="' . $this->_relgen . '"><img src="' . substr_replace($this->_opts['cache']['photos'][$i]['url'], ($this->_opts['thumbsize'] == 'Medium' ? '_q.jpg' : '_s.jpg'), -6) . '" class="' . ($this->_opts['thumbsize'] == 'Medium' ? 'medtbm' : 'smltbm') . '"/></a>';

				}
				
			}
		
		}
		else
		{
		
			if($this->_opts['type'] == 'Set')
			{

				$meta = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.photosets.getInfo&api_key=' . $this->_mainopts['apikey'] . '&photoset_id=' . $this->_opts['id'] . '&format=json&nojsoncallback=1');
				$meta = json_decode($meta['body'], true);
			
				$data = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.photosets.getPhotos&api_key=' . $this->_mainopts['apikey'] . '&photoset_id=' . $this->_opts['id'] . '&extras=url_l,url_z&format=json&nojsoncallback=1');
				$data = json_decode($data['body'], true);
				
				if($this->_opts['hidetitle'] == 'off')
				{
				
					if($type == 'shortcode')
						$this->_content .= '<h3 class="fsSetTitle">' . $meta['photoset']['title']['_content'] . '</h3>';
					else
						$this->_content .= $before_title . $meta['photoset']['title']['_content'] . $after_title;
				
				}
				
				if($this->_opts['photoselect'] == 'Random')
				{
				
					$range = ($data['photoset']['total'] - 1 < 500 ? $data['photoset']['total'] - 1 : 500);
					$gen = range(0, $range);
					shuffle($gen);
					
					for($i = 0; $i < $this->_opts['photocnt']; $i++)
					{
				
						$rand = $gen[$i];
						$this->getSetPhoto($data, $rand, $this->_opts['linktype']);
						
					}
			
				}
				else
				{
				
					for($i = 0; $i < $this->_opts['photocnt']; $i++)
					{

						$this->getSetPhoto($data, $i, $this->_opts['linktype']);
						
					}
				
				}

			}
			else
			{
			
				$meta = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.urls.lookupGallery&api_key=' . $this->_mainopts['apikey'] . '&url=' . $this->_opts['id'] . '&format=json&nojsoncallback=1');
				$meta = json_decode($meta['body'], true);
					
				$data = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.galleries.getPhotos&api_key=' . $this->_mainopts['apikey'] . '&gallery_id=' . $meta['gallery']['id'] . '&extras=url_l,url_z&format=json&nojsoncallback=1');
				$data = json_decode($data['body'], true);
					
				if($this->_opts['hidetitle'] == 'off')
				{
				
					if($type == 'shortcode')
						$this->_content .= '<h3 class="fsSetTitle">' . $meta['gallery']['title']['_content'] . '</h3>';
					else
						$this->_content .= $before_title . $meta['gallery']['title']['_content'] . $after_title;
				
				}
			
				if($this->_opts['photoselect'] == 'Random')
				{
				
					$range = ($data['photos']['total'] - 1 < 500 ? $data['photos']['total'] - 1 : 500);
					$gen = range(0, $range);
					shuffle($gen);
						
					for($i = 0; $i < $this->_opts['photocnt']; $i++)
					{
			
						$rand = $gen[$i];
						$this->getGalleryPhoto($data, $rand, $this->_opts['linktype']);
						
					}

				}
				else
				{

					for($i = 0; $i < $this->_opts['photocnt']; $i++)
					{
			
						$this->getGalleryPhoto($data, $i, $this->_opts['linktype']);	
						
					}
				
				}
				
			}

		}
		
		return $this->_content;
	
	}
	
	//get a photo and link from a photoset//
	private function getSetPhoto(&$data, $pointer, $linkType)
	{
	
		if($linkType == 'Flickr')
		{
						
			$this->_content .= '<a href="http://www.flickr.com/photos/' . $data['photoset']['owner'] . '/' . $data['photoset']['photo'][$pointer]['id'] . '" target="_blank" title="' . $data['photoset']['photo'][$pointer]['title'] . '"><img src="http://farm' . $data['photoset']['photo'][$pointer]['farm'] . '.staticflickr.com/' . $data['photoset']['photo'][$pointer]['server'] . '/' . $data['photoset']['photo'][$pointer]['id'] . '_' . $data['photoset']['photo'][$pointer]['secret'] . ($this->_opts['thumbsize'] == 'Medium' ? '_q.jpg' : '_s.jpg') . '" class="' . ($this->_opts['thumbsize'] == 'Medium' ? 'medtbm' : 'smltbm') . '"/></a>';
						
		}
		else
		{
						
			$this->_content .= '<a href="' . (isset($data['photoset']['photo'][$pointer]['url_l']) ? $data['photoset']['photo'][$pointer]['url_l'] : substr($data['photoset']['photo'][$pointer]['url_z'], 0, strpos($data['photoset']['photo'][$pointer]['url_z'], '.jpg') + 4)) . '"' . ($this->_opts['hidecaption'] == 'off' ? 'title="' . $data['photoset']['photo'][$pointer]['title'] . '"' : '') . ' class="fsFancybox" rel="' . $this->_relgen . '"><img src="http://farm' . $data['photoset']['photo'][$pointer]['farm'] . '.staticflickr.com/' . $data['photoset']['photo'][$pointer]['server'] . '/' . $data['photoset']['photo'][$pointer]['id'] . '_' . $data['photoset']['photo'][$pointer]['secret'] . ($this->_opts['thumbsize'] == 'Medium' ? '_q.jpg' : '_s.jpg') . '" class="' . ($this->_opts['thumbsize'] == 'Medium' ? 'medtbm' : 'smltbm') . '"/></a>';
						
		}
	
	
	}
	
	//get a photo and link from a gallery//
	private function getGalleryPhoto(&$data, $pointer, $linkType)
	{
	
		if($linkType == 'Flickr')
		{
						
			$this->_content .= '<a href="http://www.flickr.com/photos/' . $data['photos']['photo'][$pointer]['owner'] . '/' . $data['photos']['photo'][$pointer]['id'] . '" target="_blank" title="' . $data['photos']['photo'][$pointer]['title'] . '"><img src="http://farm' . $data['photos']['photo'][$pointer]['farm'] . '.staticflickr.com/' . $data['photos']['photo'][$pointer]['server'] . '/' . $data['photos']['photo'][$pointer]['id'] . '_' . $data['photos']['photo'][$pointer]['secret'] . ($this->_opts['thumbsize'] == 'Medium' ? '_q.jpg' : '_s.jpg') . '" class="' . ($this->_opts['thumbsize'] == 'Medium' ? 'medtbm' : 'smltbm') . '"/></a>';
						
		}
		else
		{
							
			$this->_content .= '<a href="' . (isset($data['photos']['photo'][$pointer]['url_l']) ? $data['photos']['photo'][$pointer]['url_l'] : substr($data['photos']['photo'][$pointer]['url_z'], 0, strpos($data['photos']['photo'][$pointer]['url_z'], '.jpg') +4)) . '"' . ($this->_opts['hidecaption'] == 'off' ? 'title="' . $data['photos']['photo'][$pointer]['title'] . '"' : '') . ' class="fsFancybox" rel="' . $this->_relgen . '"><img src="http://farm' . $data['photos']['photo'][$pointer]['farm'] . '.staticflickr.com/' . $data['photos']['photo'][$pointer]['server'] . '/' . $data['photos']['photo'][$pointer]['id'] . '_' . $data['photos']['photo'][$pointer]['secret'] . ($this->_opts['thumbsize'] == 'Medium' ? '_q.jpg' : '_s.jpg') . '" class="' . ($this->_opts['thumbsize'] == 'Medium' ? 'medtbm' : 'smltbm') . '"/></a>';
						
		}
	
	}
	
	public function returnCache(&$instance)
	{
	
		$store = array();
		
		if($instance['type'] == 'Set')
		{
				
			$meta = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.photosets.getInfo&api_key=' . $this->_mainopts['apikey'] . '&photoset_id=' . $instance['id'] . '&format=json&nojsoncallback=1');
			$meta = json_decode($meta['body'], true);
			$store['name'] = $meta['photoset']['title']['_content'];
							
			$data = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.photosets.getPhotos&api_key=' . $this->_mainopts['apikey'] . '&photoset_id=' . $instance['id'] . '&extras=url_l,url_z&format=json&nojsoncallback=1');
			$data = json_decode($data['body'], true);
				
			if($instance['photoselect'] == 'Random')
			{
					
				$range = ($data['photoset']['total'] - 1 < 500 ? $data['photoset']['total'] - 1 : 500);
				$gen = range(0, $range);
				shuffle($gen);
					
				for($i = 0; $i < $instance['photocnt']; $i++){
			
					$rand = $gen[$i];
								
					$store['photos'][$i]['title'] = $data['photoset']['photo'][$rand]['title'];
					
					$store['photos'][$i]['url'] = (isset($data['photoset']['photo'][$rand]['url_l']) ? $data['photoset']['photo'][$rand]['url_l'] : substr($data['photoset']['photo'][$rand]['url_z'], 0, strpos($data['photoset']['photo'][$rand]['url_z'], '.jpg') + 4));
							
					$store['photos'][$i]['flickr'] = 'http://www.flickr.com/photos/' . $data['photoset']['owner'] . '/' . $data['photoset']['photo'][$rand]['id'];
							
				}
								
			}
			else
			{
						
				for($i = 0; $i < $instance['photocnt']; $i++)
				{
							
					$store['photos'][$i]['title'] = $data['photoset']['photo'][$i]['title'];
								
					$store['photos'][$i]['url'] = (isset($data['photoset']['photo'][$i]['url_l']) ? $data['photoset']['photo'][$i]['url_l'] : substr($data['photoset']['photo'][$i]['url_z'], 0, strpos($data['photoset']['photo'][$i]['url_z'], '.jpg') + 4));
								
					$store['photos'][$i]['flickr'] = 'http://www.flickr.com/photos/' . $data['photoset']['owner'] . '/' . $data['photoset']['photo'][$i]['id'];
							
				}
						
			}

		}
		else
		{
				
			$meta = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.urls.lookupGallery&api_key=' . $this->_mainopts['apikey'] . '&url=' . $instance['id'] . '&format=json&nojsoncallback=1');
			$meta = json_decode($meta['body'], true);
			$store['name'] = $meta['gallery']['title']['_content'];
						
			$data = wp_remote_get('http://api.flickr.com/services/rest/?method=flickr.galleries.getPhotos&api_key=' . $this->_mainopts['apikey'] . '&gallery_id=' . $meta['gallery']['id'] . '&extras=url_l,url_z&format=json&nojsoncallback=1');
			$data = json_decode($data['body'], true);
				
			if($instance['photoselect'] == 'Random')
			{
					
				$range = ($data['photos']['total'] - 1 < 500 ? $data['photos']['total'] - 1 : 500);
				$gen = range(0, $range);
				shuffle($gen);
						
				for($i = 0; $i < $instance['photocnt']; $i++)
				{
			
					$rand = $gen[$i];
	
					$store['photos'][$i]['title'] = $data['photos']['photo'][$rand]['title'];
						
					$store['photos'][$i]['url'] = (isset($data['photos']['photo'][$rand]['url_l']) ? $data['photos']['photo'][$rand]['url_l'] : substr($data['photos']['photo'][$rand]['url_z'], 0, strpos($data['photos']['photo'][$rand]['url_z'], '.jpg') + 4));
									
					$store['photos'][$i]['flickr'] = 'http://www.flickr.com/photos/' . $data['photos']['photo'][$rand]['owner'] . '/' . $data['photos']['photo'][$rand]['id'];
								
				}
						
			}
			else
			{

				for($i = 0; $i < $instance['photocnt']; $i++)
				{
				
					$store['photos'][$i]['title'] = $data['photos']['photo'][$i]['title'];
									
					$store['photos'][$i]['url'] = (isset($data['photos']['photo'][$i]['url_l']) ? $data['photos']['photo'][$i]['url_l'] : substr($data['photos']['photo'][$i]['url_z'], 0, strpos($data['photos']['photo'][$i]['url_z'], '.jpg') + 4));
	
					$store['photos'][$i]['flickr'] = 'http://www.flickr.com/photos/' . $data['photos']['photo'][$i]['owner'] . '/' . $data['photos']['photo'][$i]['id'];
							
				}
					
			}
				
		}
		
		return $store;
	
	}
	
}

?>